//B.Vandeportaele 2022

#include "simulator.h"

////////////////////////////////////////////////////////
Simulator::Simulator(){

    //gestion des capteurs,inactifs par défaut, ici je ne tiens pas compte du fait que les sorties sont actives à l'état bas:
    glissierepleine=0;
    piecenonnoire=0;
    piecemetal=0;
    piecepresente=0;


    switch1=0;
    switch2=0;
    stoppeurRetracte=0;
    moteur=0;

    nbTroncons=6;
    tabTroncons=new troncon[nbTroncons];
    uint16_t xa=897;
    uint16_t xb=465;
    uint16_t xc=328;
    uint16_t xd=192;
    uint16_t ya=237;
    uint16_t yb=613-31;

    ////////////////////////////////
    {
        uint16_t numTroncon=0;
        uint16_t x1=xa;
        uint16_t x2=xb;
        uint16_t y1=ya;
        tabTroncons[numTroncon].nbPoints=(x1-x2)+1;
        tabTroncons[numTroncon].points=new pointTraj[tabTroncons[numTroncon].nbPoints];
        uint16_t numPoints=0;
        for (int x=x1;x>=x2;x--){
            tabTroncons[numTroncon].points[numPoints].x=x;
            tabTroncons[numTroncon].points[numPoints].y=y1;
            tabTroncons[numTroncon].points[numPoints].occupation=0;
            numPoints++;
        }
    }
    ////////////////////////////////
    {
        uint16_t numTroncon=1;
        uint16_t x1=xb;
        uint16_t x2=xc;
        uint16_t y1=ya;
        tabTroncons[numTroncon].nbPoints=(x1-x2)+1;
        tabTroncons[numTroncon].points=new pointTraj[tabTroncons[numTroncon].nbPoints];
        uint16_t numPoints=0;
        for (int x=x1;x>=x2;x--){
            tabTroncons[numTroncon].points[numPoints].x=x;
            tabTroncons[numTroncon].points[numPoints].y=y1;
            tabTroncons[numTroncon].points[numPoints].occupation=0;
            numPoints++;
        }
    }
    ////////////////////////////////
    {
        uint16_t numTroncon=2;
        uint16_t x1=xc;
        uint16_t x2=xd;
        uint16_t y1=ya;
        tabTroncons[numTroncon].nbPoints=(x1-x2)+1;
        tabTroncons[numTroncon].points=new pointTraj[tabTroncons[numTroncon].nbPoints];
        uint16_t numPoints=0;
        for (int x=x1;x>=x2;x--){
            tabTroncons[numTroncon].points[numPoints].x=x;
            tabTroncons[numTroncon].points[numPoints].y=y1;
            tabTroncons[numTroncon].points[numPoints].occupation=0;
            numPoints++;
        }
    }
    ////////////////////////////////
    {
        uint16_t numTroncon=3;
        uint16_t x1=xb;
        uint16_t y1=ya;
        uint16_t y2=yb;
        tabTroncons[numTroncon].nbPoints=(y2-y1)+1;
        tabTroncons[numTroncon].points=new pointTraj[tabTroncons[numTroncon].nbPoints];
        uint16_t numPoints=0;
        for (int y=y1;y<=y2;y++){
            tabTroncons[numTroncon].points[numPoints].x=x1;
            tabTroncons[numTroncon].points[numPoints].y=y;
            tabTroncons[numTroncon].points[numPoints].occupation=0;
            numPoints++;
        }
    }
    ////////////////////////////////
    {
        uint16_t numTroncon=4;
        uint16_t x1=xc;
        uint16_t y1=ya;
        uint16_t y2=yb;
        tabTroncons[numTroncon].nbPoints=(y2-y1)+1;
        tabTroncons[numTroncon].points=new pointTraj[tabTroncons[numTroncon].nbPoints];
        uint16_t numPoints=0;
        for (int y=y1;y<=y2;y++){
            tabTroncons[numTroncon].points[numPoints].x=x1;
            tabTroncons[numTroncon].points[numPoints].y=y;
            tabTroncons[numTroncon].points[numPoints].occupation=0;
            numPoints++;
        }
    }
    ////////////////////////////////
    {
        uint16_t numTroncon=5;
        uint16_t x1=xd;
        uint16_t y1=ya;
        uint16_t y2=yb;
        tabTroncons[numTroncon].nbPoints=(y2-y1)+1;
        tabTroncons[numTroncon].points=new pointTraj[tabTroncons[numTroncon].nbPoints];
        uint16_t numPoints=0;
        for (int y=y1;y<=y2;y++){
            tabTroncons[numTroncon].points[numPoints].x=x1;
            tabTroncons[numTroncon].points[numPoints].y=y;
            tabTroncons[numTroncon].points[numPoints].occupation=0;
            numPoints++;
        }
    }
}
////////////////////////////////////////////////////////
void Simulator::anime(){

    //balaye les pixels des troncons pour voir si il y a une pièce à gérer
    //il faut balayer à l'envers pour ne pas retraiter une pièce qui vient d'avancer

    /*    for (int16_t nTroncon=nbTroncons-1;nTroncon>=0;nTroncon--){
        for (int16_t nPoint=tabTroncons[nTroncon].nbPoints-1;nPoint>=0;nPoint--){
            uint8_t occupationPoint=tabTroncons[nTroncon].points[nPoint].occupation;
            if (occupationPoint!=0){
                //piece à gérer
                if (nPoint<(tabTroncons[nTroncon].nbPoints-1)){
                    tabTroncons[nTroncon].points[nPoint].occupation=0; //libere
                    tabTroncons[nTroncon].points[nPoint+1].occupation=occupationPoint; //occupe le suivant
                }
            }
        }
    }*/


    //gestion des capteurs,inactifs par défaut, ici je ne tiens pas compte du fait que les sorties sont actives à l'état bas:
    glissierepleine=0;
    piecenonnoire=0;
    piecemetal=0;
    piecepresente=0;


    int16_t glissierepleine_y=292;//position du capteur
    int16_t nTroncon;
    for (nTroncon=5; nTroncon>=3;nTroncon--) //glissière 2, 1 puis 0
        for (int16_t nPoint=tabTroncons[nTroncon].nbPoints-1;nPoint>=0;nPoint--){
            uint8_t occupationPoint=tabTroncons[nTroncon].points[nPoint].occupation;
            if (occupationPoint!=0){
                //piece à gérer
                if ( (tabTroncons[nTroncon].points[nPoint].y >(glissierepleine_y-30) ) &&  (tabTroncons[nTroncon].points[nPoint].y <(glissierepleine_y+30) ) )
                    glissierepleine=1;
            }
        }


    int16_t piece_presente_x=723;//position du capteur
    int16_t piece_metal_x=783;//position du capteur
    int16_t piece_non_noire_x=866;//position du capteur


    nTroncon=0; //debut rail 0
    for (int16_t nPoint=tabTroncons[nTroncon].nbPoints-1;nPoint>=0;nPoint--){
        uint8_t occupationPoint=tabTroncons[nTroncon].points[nPoint].occupation;
        if (occupationPoint!=0){
            //piece à gérer
            if ( (tabTroncons[nTroncon].points[nPoint].x >(piece_presente_x-30) ) &&  (tabTroncons[nTroncon].points[nPoint].x <(piece_presente_x+30) ) )
                piecepresente=1;
            if ( (tabTroncons[nTroncon].points[nPoint].x >(piece_metal_x-30) ) &&  (tabTroncons[nTroncon].points[nPoint].x <(piece_metal_x+30) ) && (occupationPoint== 2) )
                piecemetal=1;
            if ( (tabTroncons[nTroncon].points[nPoint].x >(piece_non_noire_x-30) ) &&  (tabTroncons[nTroncon].points[nPoint].x <(piece_non_noire_x+30) ) && (occupationPoint!= 3) )
                piecenonnoire=1;
        }
    }

    //pas besoin de moteur pour descendre dans les glissières
    for (nTroncon=5; nTroncon>=3;nTroncon--) //glissière 2, 1 puis 0
        for (int16_t nPoint=tabTroncons[nTroncon].nbPoints-1;nPoint>=0;nPoint--){
            uint8_t occupationPoint=tabTroncons[nTroncon].points[nPoint].occupation;
            if (occupationPoint!=0){
                //piece à gérer
                if (nPoint<(tabTroncons[nTroncon].nbPoints-2)){//si pas arrivé en bas de la glissière
                    if (nPoint>(tabTroncons[nTroncon].nbPoints-2-2* rayonOccupationDisque)){ //la pièce est basse, il ne peut pas y en avoir une autre dessous
                        tabTroncons[nTroncon].points[nPoint].occupation=0; //libere
                        tabTroncons[nTroncon].points[nPoint+1].occupation=occupationPoint; //occupe le suivant
                    }else{ //il faut tester si il y en a une dessous
                        bool libre=true;
                        for (int16_t nn=0;nn<2*rayonOccupationDisque;nn++){
                            if (tabTroncons[nTroncon].points[nPoint+1+nn].occupation!=0){
                                libre=false;
                                break;
                            }
                        }
                        if (libre){
                            tabTroncons[nTroncon].points[nPoint].occupation=0; //libere
                            tabTroncons[nTroncon].points[nPoint+1].occupation=occupationPoint; //occupe le suivant
                        }
                    }
                }
            }
        }
    if (moteur==1){
        nTroncon=2; //rail 2
        for (int16_t nPoint=tabTroncons[nTroncon].nbPoints-1;nPoint>=0;nPoint--){
            uint8_t occupationPoint=tabTroncons[nTroncon].points[nPoint].occupation;
            if (occupationPoint!=0){
                //piece à gérer
                if (nPoint<(tabTroncons[nTroncon].nbPoints-1)){
                    //il faut tester si il y en a une devant
                    bool libre=true;
                    for (int16_t nn=0;nn<2*rayonOccupationDisque;nn++){
                        if (nPoint+1+nn<tabTroncons[nTroncon].nbPoints)
                            if (tabTroncons[nTroncon].points[nPoint+1+nn].occupation!=0){
                                libre=false;
                                break;
                            }
                    }
                    //la glissière 2 peut aussi bloquer
                    if (nPoint>=tabTroncons[nTroncon].nbPoints-(2*rayonOccupationDisque)){
                        //alors il faut tester les rayonOccupationDisque premiers de glissière 2
                        for (int16_t nn=0;nn<rayonOccupationDisque;nn++){
                            if (tabTroncons[5].points[nn].occupation!=0){
                                libre=false;
                                break;
                            }
                        }
                    }
                    if (libre){
                        tabTroncons[nTroncon].points[nPoint].occupation=0; //libere
                        tabTroncons[nTroncon].points[nPoint+1].occupation=occupationPoint; //occupe le suivant
                    }
                }else{//arrive a l'extremité
                    //vers glissière 2
                    tabTroncons[nTroncon].points[nPoint].occupation=0; //libere
                    tabTroncons[5].points[0].occupation=occupationPoint; //occupe le suivant
                }

            }

        }
        nTroncon=1; //rail 1
        for (int16_t nPoint=tabTroncons[nTroncon].nbPoints-1;nPoint>=0;nPoint--){
            uint8_t occupationPoint=tabTroncons[nTroncon].points[nPoint].occupation;
            if (occupationPoint!=0){
                //piece à gérer
                if (nPoint<(tabTroncons[nTroncon].nbPoints-1)){
                    //il faut tester si il y en a une devant
                    bool libre=true;
                    for (int16_t nn=0;nn<2*rayonOccupationDisque;nn++){
                        if (nPoint+1+nn<tabTroncons[nTroncon].nbPoints)
                            if (tabTroncons[nTroncon].points[nPoint+1+nn].occupation!=0){
                                libre=false;
                                break;
                            }
                    }
                    //la glissière 1 peut aussi bloquer
                    if (nPoint>=tabTroncons[nTroncon].nbPoints-(2*rayonOccupationDisque)){
                        //alors il faut tester les rayonOccupationDisque premiers de glissière 1
                        for (int16_t nn=0;nn<rayonOccupationDisque;nn++){
                            if (tabTroncons[4].points[nn].occupation!=0){
                                libre=false;
                                break;
                            }
                        }
                    }
                    //le rail2 peut aussi bloquer
                    if (nPoint>=tabTroncons[nTroncon].nbPoints-(2*rayonOccupationDisque)){
                        //alors il faut tester les rayonOccupationDisque premiers de rail 2
                        for (int16_t nn=0;nn<rayonOccupationDisque;nn++){
                            if (tabTroncons[2].points[nn].occupation!=0){
                                libre=false;
                                break;
                            }
                        }
                    }
                    if (libre){
                        tabTroncons[nTroncon].points[nPoint].occupation=0; //libere
                        tabTroncons[nTroncon].points[nPoint+1].occupation=occupationPoint; //occupe le suivant
                    }
                }else{//arrive a l'aiguillage
                    if (switch2==1){  //vers glissière 1
                        tabTroncons[nTroncon].points[nPoint].occupation=0; //libere
                        tabTroncons[4].points[0].occupation=occupationPoint; //occupe le suivant
                    }else{ //vers rail 2
                        tabTroncons[nTroncon].points[nPoint].occupation=0; //libere
                        tabTroncons[2].points[0].occupation=occupationPoint; //occupe le suivant
                    }

                }
            }
        }


        nTroncon=0; //debut rail 0
        for (int16_t nPoint=tabTroncons[nTroncon].nbPoints-1;nPoint>=0;nPoint--){
            //cas particulier pour la position du stoppeur:
            if ((nPoint==185-rayonOccupationDisque) && (stoppeurRetracte==0)){
                //il ne faut rien faire... c'est bloqué
            }else{
                uint8_t occupationPoint=tabTroncons[nTroncon].points[nPoint].occupation;
                if (occupationPoint!=0){
                    //piece à gérer
                    if (nPoint<(tabTroncons[nTroncon].nbPoints-1)){
                        //il faut tester si il y en a une devant
                        bool libre=true;
                        for (int16_t nn=0;nn<2*rayonOccupationDisque;nn++){
                            if (nPoint+1+nn<tabTroncons[nTroncon].nbPoints)
                                if (tabTroncons[nTroncon].points[nPoint+1+nn].occupation!=0){
                                    libre=false;
                                    break;
                                }
                        }
                        //la glissière 0 peut aussi bloquer
                        if (nPoint>=tabTroncons[nTroncon].nbPoints-(2*rayonOccupationDisque)){
                            //alors il faut tester les rayonOccupationDisque premiers de glissière 0
                            for (int16_t nn=0;nn<rayonOccupationDisque;nn++){
                                if (tabTroncons[3].points[nn].occupation!=0){
                                    libre=false;
                                    break;
                                }
                            }
                        }
                        //le rail1 peut aussi bloquer
                        if (nPoint>=tabTroncons[nTroncon].nbPoints-(2*rayonOccupationDisque)){
                            //alors il faut tester les rayonOccupationDisque premiers de rail 1
                            for (int16_t nn=0;nn<rayonOccupationDisque;nn++){
                                if (tabTroncons[1].points[nn].occupation!=0){
                                    libre=false;
                                    break;
                                }
                            }
                        }
                        if (libre){
                            tabTroncons[nTroncon].points[nPoint].occupation=0; //libere
                            tabTroncons[nTroncon].points[nPoint+1].occupation=occupationPoint; //occupe le suivant
                        }

                    }else{//arrive a l'aiguillage
                        if (switch1==1) { //vers glissière 0
                            tabTroncons[nTroncon].points[nPoint].occupation=0; //libere
                            tabTroncons[3].points[0].occupation=occupationPoint; //occupe le suivant

                        }else{ //vers rail 1
                            tabTroncons[nTroncon].points[nPoint].occupation=0; //libere
                            tabTroncons[1].points[0].occupation=occupationPoint; //occupe le suivant
                        }
                    }
                }
            }

        }
    }
}
////////////////////////////////////////////////////////
bool Simulator::ajoutePiece(uint8_t type){  //retourne true si la pièce a pu être ajoutée
    //il faut verifier que les 31 première places soient libres
    for (int i=0;i<rayonOccupationDisque*2;i++)
        if (tabTroncons[0].points[i].occupation!=0)
            return false;
    tabTroncons[0].points[0].occupation=type;
    return true;
}
////////////////////////////////////////////////////////
bool Simulator::retirePiece(uint8_t glissiere){ //retourne true si la pièce a pu être retirée
    //tabTroncons[0].points[0].occupation=type;
    int16_t nTroncon=-1;

    switch(glissiere){
    case 0:
        nTroncon=3;
        break;
    case 1:
        nTroncon=4;
        break;
    case 2:
        nTroncon=5;
        break;
    }
    //cherche la pièce la plus basse dans la glissière et la retire
    for (int16_t nPoint=tabTroncons[nTroncon].nbPoints-1;nPoint>=0;nPoint--){
        uint8_t occupationPoint=tabTroncons[nTroncon].points[nPoint].occupation;
        if (occupationPoint!=0){
            //piece à retirer
            tabTroncons[nTroncon].points[nPoint].occupation=0; //libere
            return true;
        }
    }
    return false; //pas de piece trouvée
}


