//B.Vandeportaele 2022

#ifndef SIMULATOR_H
#define SIMULATOR_H


#include <stdint.h>


const uint8_t rayonOccupationDisque=35;
//codage pièce et occupation 0=libre 1=rouge 2=metal 3=noir
//peut être: bit 7=1 indique centre pièce

struct pointTraj{
    uint16_t x,y;
    uint8_t occupation;
};

struct troncon{
    pointTraj* points;
    uint16_t nbPoints;
};

class Simulator
{

public:
    Simulator ();
    uint16_t nbTroncons;
    troncon* tabTroncons;

    void anime();
    bool ajoutePiece(uint8_t type);
    bool retirePiece(uint8_t glissiere);

    int switch1;
    int switch2;
    int stoppeurRetracte;
    int moteur;
    int glissierepleine;
    int piecenonnoire;
    int piecemetal;
    int piecepresente;


};


#endif // SIMULATOR_H
